﻿Imports LibraryManagementSystem

Public Class MainWindow

    ' define the DBMS object
    Public DBMS As New DBMSClass

    ' define the staff object
    Public StaffObject As StaffClass

    ' this function executes when the form first appears
    Private Sub MainWindow_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ' open the db
        Dim result As String = DBMS.OpenDB()
        If result <> "OK" Then
            MsgBox("Error openining the database." & vbNewLine & result, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Error")
            End
        End If

        ' create login form
        Dim MyLoginForm As New LoginForm
        MyLoginForm.ShowDialog()
        StaffObject = StaffClass.Login(DBMS, MyLoginForm.UsernameTextBox.Text, MyLoginForm.PasswordTextBox.Text)
        If StaffObject Is Nothing Then
            MsgBox("Invalid username or password", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Error")
            End
        End If

        'if the admin just logged in, then we should remove other tabs
        If StaffObject.GetEmployeeLoginName = "admin" Then


            ' remove the tab related to normal employees
            TabControl1.TabPages.RemoveAt(1)
            ShelfToolStripMenuItem.Visible = False

            ' display all staff information
            If Not StaffClass.FillDGVWithStaffInfo(DGV, DBMS) Then
                MsgBox("Error while displaying staff information", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Error")
                End
            End If


        Else


            ' remove tabs and menus for admin
            TabControl1.TabPages.RemoveAt(0)
            Me.StaffToolStripMenuItem.Visible = False


            ' fill the dgv with the shelf info
            If Not ShelfClass.FillDGVWithShelfInfo(DGV2, DBMS) Then
                MsgBox("Error while displaying shelf information", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Error")
                End
            End If
        End If


    End Sub

    ' this is used to add a new staff member
    Private Sub AddNewStaffMemberToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddNewStaffMemberToolStripMenuItem.Click
        Dim Tmp As New AddStaffForm
        If Tmp.ShowDialog() = Windows.Forms.DialogResult.OK Then
            StaffClass.FillDGVWithStaffInfo(DGV, DBMS)
        End If

    End Sub

    ' this one is used to edit staff member information
    Private Sub EditStaffMemberInformationToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EditStaffMemberInformationToolStripMenuItem.Click
        If DGV.SelectedRows.Count = 0 Then
            MsgBox("You should select a staff member", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Error")
            Exit Sub
        End If

        ' load the object from db
        Dim StaffName As String = DGV.SelectedRows(0).Cells("EmployeeLoginName").Value
        If StaffName = "admin" Then
            MsgBox("admin account can't be edited", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Error")
            Exit Sub
        End If
        Dim TMP As New LibraryManagementSystem.StaffClass
        If Not TMP.LoadFromDB(DBMS, StaffName) Then
            MsgBox("Unable of loading staff information from db", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Error")
            Exit Sub
        End If

        ' edit the information
        Dim EditStaffObject As New EditStaffForm
        EditStaffObject.StaffObj = TMP
        If EditStaffObject.ShowDialog = Windows.Forms.DialogResult.OK Then

            ' display all staff information
            If Not StaffClass.FillDGVWithStaffInfo(DGV, DBMS) Then
                MsgBox("Error while displaying staff information", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Error")
            End If
        End If
    End Sub

    ' this function is used to remove staff member
    Private Sub RemoveStaffMemberToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RemoveStaffMemberToolStripMenuItem.Click
        If DGV.SelectedRows.Count = 0 Then
            MsgBox("You should select a staff member", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Error")
            Exit Sub
        End If

        ' get the staff member name
        Dim StaffName As String = DGV.SelectedRows(0).Cells("EmployeeLoginName").Value
        If StaffName = "admin" Then
            MsgBox("admin account can't be removed", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Error")
            Exit Sub
        End If
        Dim TMP As New LibraryManagementSystem.StaffClass
        If Not TMP.LoadFromDB(DBMS, StaffName) Then
            MsgBox("Unable of loading staff information from db", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Error")
            Exit Sub
        End If

        ' remove the staff information from db
        If Not TMP.RemoveFromDB(DBMS, True) Then
            MsgBox("Unable of removing staff member from db", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Error")
        Else
            ' display all staff information
            If Not StaffClass.FillDGVWithStaffInfo(DGV, DBMS) Then
                MsgBox("Error while displaying staff information", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Error")
            End If
        End If
    End Sub

    ' used to add a shelf
    Private Sub AddNewShelfToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddNewShelfToolStripMenuItem.Click
        Dim AddShelfObj As New AddShelfForm
        If AddShelfObj.ShowDialog = Windows.Forms.DialogResult.OK Then

            ' fill the dgv with the shelf info
            If Not ShelfClass.FillDGVWithShelfInfo(DGV2, DBMS) Then
                MsgBox("Error while displaying shelf information", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Error")
            End If

        End If
    End Sub

    ' used to edit shelf information
    Private Sub EditShelfToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EditShelfToolStripMenuItem.Click
        ' make sure shelf is being selected
        If DGV2.SelectedRows.Count = 0 Then
            Exit Sub
        End If

        ' load the object
        Dim ShelfObj As New LibraryManagementSystem.ShelfClass
        Dim ShelfNo As String = DGV2.SelectedRows(0).Cells("shelfno").Value
        If Not ShelfObj.LoadFromDB(DBMS, ShelfNo) Then
            MsgBox("Error while loading shelf information", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Error")
        Else
            Dim EditShelfFormObject As New EditShelfForm
            EditShelfFormObject.OriginalShelfInfo = ShelfObj
            If EditShelfFormObject.ShowDialog = Windows.Forms.DialogResult.OK Then

                ' fill the dgv with the shelf info
                If Not ShelfClass.FillDGVWithShelfInfo(DGV2, DBMS) Then
                    MsgBox("Error while displaying shelf information", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Error")
                End If

            End If
        End If
    End Sub

    ' this is used to remove a shelf 
    Private Sub RemoveShelfToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RemoveShelfToolStripMenuItem.Click
        ' make sure shelf is being selected
        If DGV2.SelectedRows.Count = 0 Then
            Exit Sub
        End If

        ' load the object
        Dim ShelfObj As New LibraryManagementSystem.ShelfClass
        Dim ShelfNo As String = DGV2.SelectedRows(0).Cells("shelfno").Value
        If Not ShelfObj.LoadFromDB(DBMS, ShelfNo) Then
            MsgBox("Error while loading shelf information", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Error")
            Exit Sub
        End If

        ' delete the object
        If Not ShelfObj.RemoveFromDB(DBMS, True) Then
            MsgBox("Error while deleting shelf information", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Error")
        Else

            ' fill the dgv with the shelf info
            If Not ShelfClass.FillDGVWithShelfInfo(DGV2, DBMS) Then
                MsgBox("Error while displaying shelf information", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Error")
            End If

        End If

    End Sub
End Class
